//// Ejercicio 2-8 ////
////---------------////
clear;
// Definición de variables del sistema hidráulico //
A_1 = 1;    // Área transversal tanque 1 [m^2]
A_2 = 1;    // Área transversal tanque 2 [m^2]
A_3 = 1;    // Área transversal tanque 3 [m^2]
R_1 = 2;    // Resistencia dinámica entre tanques 1 y 3 [s/m]
R_2 = 1;    // Resistencia dinámica entre tanques 1 y 2 [s/m]
R_3 = 1;    // Resistencia dinámica entre tanques 2 y 3 [s/m]

// Cálculo de las matrices del modelo de estados //
A = [-1/A_1*(1/R_1+1/R_2) 1/(R_2*A_1) 1/(R_1*A_1);
     1/(R_2*A_2) -1/A_2*(1/R_2+1/R_3) 1/(R_3*A_2);
     1/(R_1*A_3) 1/(R_3*A_3) -1/A_3*(1/R_1+1/R_3)];
B = [1/A_1 0 0]';
C = [0 1 0];
D = 0;

// Controlabilidad
U = [B A*B A^2*B];  // Matriz controlabilidad (U)
det_u = det(U);     // Determinante de U
// Observabilidad
V = [C;C*A;C*A^2];  // Matriz observabilidad (V)
det_v = det(V);     // Determinante de V

//// Transformacion al Modelo Canónico Controlable (MCC)
////----------------------------------------------
// Cálculos auxiliares
s = poly(0,"s");                // Variable de Laplace
I_2 = eye(3,3);                 // Matriz identidad de 3x3
sia = s*I_2-A;                  // sI-A
det_sia = det(sia);             // Det(sI-A)

// Matrices del MCC teóricas:
Acc = [0 1 0;0 0 1;0 -6 -5];    
Bcc = [0 0 1]';

// Inversa de la matriz controlabilidad del MCC:
Ucc_inv = [6 5 1;5 1 0;1 0 0]
// Matriz controlabilidad del MCC calculada a partir de su inversa:
Ucc_1 = inv(Ucc_inv);
// Matriz controlabilidad del MCC (Ucc) calculada con Bcc y Acc:
Ucc_2 = [Bcc Acc*Bcc Acc^2*Bcc];    

// Matrices de Transformación al MCC
T = U*Ucc_inv;          // Matriz de Transformacion (T)
T_inv_1 = inv(T);       // Inversa de T calculada a partir de T
U_inv = inv(U);         // Inversa de U
// Inversa de T calculada con Ucc y la inversa de U:
T_inv_2 = Ucc_2*U_inv;   

//// Matrices del MCC calculadas con T:
Acc_T = T_inv_1*A*T;
Bcc_T = T_inv_1*B;
Ccc_T = C*T;

//// Matrices originales calculadas con T a partir del MCC:
A_T = T*Acc*T_inv_1;
B_T = T*Bcc;

//// Funcion transferencia:
G_s = C*inv(sia)*B;
//// Busco la salida que me permite garantizar observabilidad
C_1 = [1 0 0];
C_3 = [0 0 1];
G_s_1 = C_1*inv(sia)*B;
G_s_2 = C_3*inv(sia)*B;
